#************************************************************************************
#                 DAE Tools Project: www.daetools.com
#                 Copyright (C) Dragan Nikolic
#************************************************************************************
# DAE Tools is free software; you can redistribute it and/or modify it under the
# terms of the GNU General Public License version 3 as published by the Free Software
# Foundation. DAE Tools is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
# PARTICULAR PURPOSE. See the GNU General Public License for more details.
# You should have received a copy of the GNU General Public License along with the
# DAE Tools software; if not, see <http://www.gnu.org/licenses/>.
#************************************************************************************
QT -= core gui
TARGET = cxx-cs-benchmark
TEMPLATE = app

CONFIG(debug, debug|release) {
    OBJECTS_DIR = debug
}

CONFIG(release, debug|release) {
    OBJECTS_DIR = release
}
DESTDIR = .

unix::QMAKE_CXXFLAGS += -std=c++11 -fopenmp

unix::QMAKE_CFLAGS_RELEASE   -= -O2
unix::QMAKE_CFLAGS_RELEASE   -= -O2
unix::QMAKE_CFLAGS_RELEASE   += -O3
unix::QMAKE_CXXFLAGS_RELEASE += -O3

unix::QMAKE_CFLAGS           += -std=c99
unix::QMAKE_CFLAGS_WARN_ON    = -Wall -Wextra -Wno-unused-parameter -Wno-unused-variable -Wno-sign-compare
unix::QMAKE_CXXFLAGS_WARN_ON  = -Wall -Wextra -Wno-unused-parameter -Wno-unused-variable -Wno-sign-compare

# Valgrind profilig
#unix::QMAKE_CXXFLAGS += -g

LIBS += -lgomp

SOURCES += adouble.cpp \
           model.cpp \
           compute_stack_openmp.cpp \
           main.cpp

HEADERS += model.h \
           adouble.h \
           benchmark_1_cxx.h \
           compute_stack.h \
           call_stats.h \
           compute_stack_openmp.h
